package fi.em.formPlugin;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

/**
 * @author cjz
 * @date 2024/10/25 16:37
 * @description:根据人力薪酬分录自动带出人员银行账户
 */
public class SalaryBankNumEditPlugin extends AbstractFormPlugin {

    private static String nckd_sae_jobid="nckd_sae_jobid";//人力薪酬一般员工工号标识
    private static String nckd_sae_banknumber="nckd_sae_banknumber";//人力薪酬一般员工银行账号标识
    private static String nckd_see_jobid="nckd_see_jobid";//人力薪酬内退工号标识
    private static String nckd_see_banknumber="nckd_see_banknumber";//人力薪酬内退银行账号标识
    private static String nckd_salaryentry="nckd_salaryentry";//人力薪酬一般员工分录标识
    private static String nckd_salaryentryre="nckd_salaryentryre";//人力薪酬内退分录标识

    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.beforePropertyChanged(e);
        String name = e.getProperty().getName();//获取字段标识
        //获取当前单据
        DynamicObject dynamicObject=this.getModel().getDataEntity(true);
        //人力薪酬一般员工工号带出银行账号
        if (nckd_sae_jobid.equals(name)) {
            //人力一般分录
            DynamicObjectCollection dynamicObjectCollection=dynamicObject.getDynamicObjectCollection(nckd_salaryentry);
            for (DynamicObject item:dynamicObjectCollection) {
                //人力一般工号
                String sae_jobid=item.getString(nckd_sae_jobid);
                QFilter qFilter=new QFilter("nckd_payeenum.number", QCP.equals,sae_jobid);
                //数据状态为启用
                qFilter.and("nckd_datastatus",QCP.equals,"A");
                //查询员工收款信息表
                DynamicObject dynamicObjects= BusinessDataServiceHelper
                        .loadSingle("nckd_payinformation","id,nckd_payaccount",new QFilter[]{qFilter});
                //存在数据则设值
                if (dynamicObjects!=null) {
                    //设置银行账号
                    this.getModel().setValue(nckd_sae_banknumber,dynamicObjects.getString("nckd_payaccount"));
                }
            }
        }

        //人力薪酬内退工号带出银行账号
        if (nckd_see_jobid.equals(name)) {
            //人力内退分录
            DynamicObjectCollection dynamicObjectCollection=dynamicObject.getDynamicObjectCollection(nckd_salaryentryre);
            for (DynamicObject item:dynamicObjectCollection) {
                //人力一般工号
                String sae_jobid=item.getString(nckd_see_jobid);
                QFilter qFilter=new QFilter("nckd_payeenum.number", QCP.equals,sae_jobid);
                //数据状态为启用
                qFilter.and("nckd_datastatus",QCP.equals,"A");
                //查询员工收款信息表
                DynamicObject dynamicObjects= BusinessDataServiceHelper
                        .loadSingle("nckd_payinformation","id,nckd_payaccount",new QFilter[]{qFilter});
                //存在数据则设值
                if (dynamicObjects!=null) {
                    //设置银行账号
                    this.getModel().setValue(nckd_see_banknumber,dynamicObjects.getString("nckd_payaccount"));
                }
            }
        }
    }


}
